////////////////////////////////////////////////////////////////////////////////
// NeoBasic: BlackBerry (957,857,950 and 850) version          athlor@gmail.com
////////////////////////////////////////////////////////////////////////////////
#include <pager.h>
#include <ribbon.h>
#include "icon.h"
//#include "ascii4x6.h" // 40 column font
#include "bold4x6.h"  // Bold 40 column font
#define SMAX 999
#define CMAX 256
#define BMAX 999
#define LMAX 9999

char VersionPtr[] = "NeoBasic 40";
int AppStackSize = 3000;
typedef char *STRPTR;

// Changing these to dynamically allocated SAVED 48k of ram
int *E;//[SMAX]; // Subroutine line number stack
int *L;//[CMAX]; // FOR loop beginning line number
int *M;//[CMAX]; // FOR loop maximum index value
int *P;//[CMAX]; // Program variable value
int l, i, j;
int *C;       // Subroutine stack pointer
char *B;//[BMAX]; // Command input buffer
char F[2];    // Temporary search string
STRPTR *m;//[LMAX+1]; // Pointers to lines of program
STRPTR p, q, x, y, z, s, d;
char tmp[64];

MESSAGE MSG;
LcdConfig LcdCfg;

void ClrPrg(void)
{
  for (i=0; i<LMAX; i++)
    if (m[i]) {
      RimFree(m[i]);
      m[i]=0;
    }
}

int Y(void); // Required prototype

void puts(char *s)
{
  LcdPutStringXY(0,LcdCfg.height-6,s,-1,0);
  LcdScroll(6);
}

void G(void) // Get program line from buffer
{
  l = strtol(B,0,0);
  if (m[l]) RimFree(m[l]);
  if ((p=(char *)strstr(B," ")))
    strcpy(m[l]=(char *)RimMalloc(strlen(p)),p+1);
  else  m[l]=0;
}

int W(void)
{
  int o = Y();
  switch (*p++) {
  case '*': return o * W(); break;
  case '/': return o / W();
  default:  p--; return o;
  }
}

int V(void)
{
  int o = W();
  switch (*p++) {
  case '+': return o + V(); break;
  case '-': return o - V();
  default:  p--; return o;
  }
}

int K(void)
{
  int o = V();
  switch (*p++) {
  case '$': return o <= K(); break; // Less than or equal to
  case '!': return o >= K();        // Greater than or equal to
  default:  p--; return o;
  }
}

int J(void)
{
  int o = K();
  switch (*p++) {
  case '<': return o < J(); break;
  case '>': return o > J();
  default:  p--; return o;
  }
}

int S(void) // Recursive descent parser for arithmetic/logical expressions
{
  int o = J();
  switch (*p++) {
  case '=': return o == S(); break;
  case '#': return o != S();
  default:  p--; return o;
  }
}

int Y(void)
{
  int o;
  return (*p == '-')?(p++, -Y()):(*p >= '0' && *p <= '9') ? strtol(p,&p,10)
                           :(*p == '(') ? (p++, o = S(), p++, o) : P[*p++];
}

void run(void)
{
  AlertConfiguration VIB = {
   50,                 // Duty
   1,                  // Volume (initial)
   1,                  // Volume (max)
   1,                  // Repetitions
   10,                 // VibrateTime (1/10 sec)
   CONTINUOUS_VIBRATE, // VibrateType
   VIBRATE_ALERT,      // InHolsterNotify
   VIBRATE_ALERT,      // OutOfHolsterNotify
   0};                 // Pause

  C=E;
  l=1; j=0; // ADDED j initialization
  for(i=0; i<CMAX; P[i++]=0); // initialize variables to 0

  while (l) { // RUNNING loop
    while (!(s = m[l])) l++; // Skip unused line numbers

    if (!strstr(s, "\"")) { // DAMNED HEFTY SPEED TAX!    Move to init !!!!
      while((p=(char *)strstr(s, "<>"))) *p++ ='#',*p =' '; // Change Not =
      while((p=(char *)strstr(s, "<="))) *p++ ='$',*p =' '; // Change Less =
      while((p=(char *)strstr(s, ">="))) *p++ ='!',*p =' '; // Change Grtr =
    } // Executed before EVERY line ALL the time!  MUST be a better way!
    d=B;
    while ((*F = *s)) {
      if (*s == '"') j++;
      if (j&1 || !strstr(" \t", F)) *d++ = *s; // TAB ??
      s++;
    }
    *d-- = j = 0;
    LcdForceRefresh();
    RimTaskYield();

    if (B[1] != '=') // If not a variable assignment
      switch (*B) {
      case 'w': // WAIT
        p = B+4;
        RimSleep(S());
      case 0x27: // SHORT REM '
        break;
      case 'k': // KEY
        while(RimGetMessage(&MSG),MSG.Event!=KEY_DOWN);
        RimSprintf(tmp, 64, "%d", MSG.SubMsg);
        p = tmp;
        P[*d] = S();
        break;
      case 's': // SOUND
        p = B+5;
        RimSpeakerBeep(S(), 50, 50, 100);
        break;
      case 'v': // VIBRATE
        p = B+7;
        VIB.vibrateTime = S();
        RimTestAlert(TONE_SEQUENCE_1,&VIB);
        break;
      case 'e': // END
        l = -1;
        break;
      case 'r': // REM
        if (B[2] != 'm') l = *--C; // RETURN
        break;
      case 'i':
        if (B[1] == 'n') { // INPUT
          char NC = 0; tmp[NC] = 0; // Clear line buffer
          do{
            LcdPutStringXY(0, LcdCfg.height-6, tmp, -1, 0); // Command line
            LcdPutStringXY(-1,-1," ",1,TEXT_INVERT);      // Cursor
            LcdClearToEndOfLine();
            RimGetMessage(&MSG);
            if(MSG.Event==KEY_DOWN){
              if(MSG.SubMsg==KEY_BACKSPACE) {
                if (NC>0) tmp[--NC]=0;
              } else {
                tmp[NC++]=MSG.SubMsg; tmp[NC]=0;
              }
            }
          }while(MSG.SubMsg!=KEY_ENTER);
          LcdPutStringXY(0, LcdCfg.height-6, tmp, -1, 0);
          LcdClearToEndOfLine(); LcdScroll(6);
          p=tmp;
          P[*d] = S();
        } else { // IF
          *(q = (char *)strstr(B, "th"))=0; // THEN
          p = B+2;
          if (S()) {
            p = q+4;
            l = S()-1;
          }
        }
        break;
      case 'p': // PRINT string
        if (B[5] == '"') {
          *d = 0;
          puts(B+6);
        } else { // PRINT number
          p = B+5;
          RimSprintf(tmp, 64, "%d", S());
          puts(tmp);
        }
        break;
      case 'g': // GOTO
        p = B+4;
        if (B[2] == 's') { // GOSUB
          *C++ = l;
          p++;
        }
        l = S()-1;
        break;
      case 'f': // FOR
        *(q = (char *)strstr(B,"to"))=0; // TO
        p = B+5;
        P[i=B[3]] = S();
        p = q+2;
        M[i] = S();
        L[i] = l;
        break;
      case 'n': // NEXT
        if (++P[*d] <= M[*d]) l = L[*d];
    } else {
      if (B[3] == 'n') // RND()
      {
        p = B+5;
        P[*B] = rand()/(32767/S())+1;
      } else { // Variable Assignment
        p = B+2;
        P[*B] = S();
      }
    }
    l++;
  } // end while l (RUNNING loop)
}

void NBThread(void)
{
  char NC=0;    // Line buffer next char
  char buf[64]; // Immediate mode buffer
  HandleType H; FileType F; // Load/Save
  PID pid;
  pid.Name = VersionPtr;
  pid.EnableForeground = TRUE;
  pid.Icon = NULL;
  RimSetPID(&pid);
  LcdGetConfig(&LcdCfg);
  E=(int *)RimMalloc(SMAX*sizeof(int));//[SMAX]; // Subroutine line number stack
  L=(int *)RimMalloc(CMAX*sizeof(int));//[CMAX]; // FOR loop beginning line number
  M=(int *)RimMalloc(CMAX*sizeof(int));//[CMAX]; // FOR loop maximum index value
  P=(int *)RimMalloc(CMAX*sizeof(int));//[CMAX]; // Program variable value
  B=(char *)RimMalloc(BMAX*sizeof(char));//[BMAX]
  m=(STRPTR *)RimMalloc((LMAX+1)* sizeof(STRPTR));//[LMAX+1]; // Pointers to lines of program
  for (i=0; i<LMAX; i++) m[i]=0; // Initialize pointers

  B[NC]=0; // Line buffer end of string
  srand(RimGetTicks()); // Seed rand

//LcdReplaceFont(2,&ascii4x6);
  LcdReplaceFont(2,&Bold_ascii4x6); // Actually squarer !
  LcdSetCurrentFont(2); // Set to 40 col font
  puts("NeoBasic v1.0b");
  puts("40 column version");
  puts(""); puts("Ready");
  m[LMAX] = "e"; // Add END to end

  for (;;)  // Start message loop
  {
    LcdPutStringXY(0, LcdCfg.height-6, B, -1, 0); // Command line
    LcdPutStringXY(-1,-1," ",1,TEXT_INVERT);      // Cursor
    LcdClearToEndOfLine();
    RimGetMessage(&MSG);

    switch (MSG.Device) {
    case DEVICE_KEYPAD:
      switch (MSG.Event) {
      case KEY_DOWN:
      {
        switch (MSG.SubMsg) {
        case KEY_ESCAPE: // ESC key exits
quit:     ClrPrg();
          RimFree(E);
          RimFree(L);
          RimFree(M);
          RimFree(P);
          RimFree(B);
          RimFree(m);
          RibbonShowRibbon();
          RimTerminateThread();
          break;
        case KEY_ENTER:
          LcdPutStringXY(0, LcdCfg.height-6, B, -1, 0);
          LcdClearToEndOfLine();
          LcdScroll(6);

          switch (*B) { // Immediate commands
          case 'l':
            if (B[1] == 'o') // LOAD Command
            {
              H=DbGetHandle(B+5); F=DbFileOpen(H,256); i=0;
              for(j=0; j<DbSize(H,TRUE); j++)
              {
                DbFileRead(F,&B[i],1);
                if(B[i] !='\n') {
                  if(B[i] !='\r') i++; // Ignore Win/Dos RET
                } else {
                  B[i]=0; // End of string
                  i=0;
                  G();
                }
              }
              DbFileClose(F,TRUE);
            } else { // LIST command
              for (i=0; i<LMAX; i++){
                if (m[i]) {
                  RimSprintf(buf,64," %d %s\n", i, m[i]);
                  puts(buf); RimTaskYield(); // Ensure visible list
                }
                if(RimPeekMessage()==TRUE) break; // Test for break
              }
            }
            break;
          case 's': // SAVE command
            H=DbGetHandle(B+5); F=DbFileOpen(H,256);
            for (i=0; i<LMAX; i++)
              if (m[i]) {
                RimSprintf(buf, 64, "%d %s\n", i, m[i]);
                DbFileWrite(F,buf,strlen(buf));
              }
            DbFileClose(F,TRUE);
            break;
          case 'n': // NEW command
            ClrPrg();
            break;
          case 'f': // FILES command
            H=DbFindNext(-1,"*.bas");
            while(H>=0) {
              RimSprintf(buf,63,"%5d %s",DbSize(H,TRUE),DbName(H));
              puts(buf); H=DbFindNext(H,"*.bas");
            }
            break;
          case 'r': // RUN command
            run();
            break;
          case 'd': // DELETE Command
            if(DbDelete(B+7)==DB_OK) puts("OK");
            break;
          case 'q': goto quit;
          case 0:
          default: // Add Line
            G();
          }
          NC = 0;    // Reset line buffer len to 0
          B[NC] = 0; // Line buffer end of string 
          puts("Ready"); // READY PROMPT
          break;
        case KEY_BACKSPACE:
          if (NC>0) B[--NC]=0;
          break;
        default:
          B[NC++]=MSG.SubMsg; B[NC]=0;
        }
        break;
      }                         // End case
      }                         // End switch
    }                           // End switch
  }                             // End message loop
}

void PagerMain(void)
{
  RibbonRegisterFunction(VersionPtr,&IconBMP,0,40,NBThread,AppStackSize);
}

